# Example: ebgp in chain

## **Topology diagram**

![topology](/img/topo.tst.png)

## **Configuration**

**r1:**
```
hostname r1
buggy
!
logging file debug ./slot0r1-log.run
!
vrf definition cust1
 exit
!
vrf definition tester
 exit
!
interface ethernet1
 lldp enable
 vrf forwarding cust1
 ipv4 address 3.3.3.1 255.255.255.252
 no shutdown
 no log-link-change
 exit
!
console0
 no exec authorization
 no login authentication
 exit
!
!
ipv4 route cust1 0.0.0.0 0.0.0.0 3.3.3.2
!
!
!
!
!
!
!
!
!
!
!
!
!
!
!
!
!
!
!
!
!
!
!
!
!
server telnet tester
 security protocol telnet
 exec colorize header
 exec monitor
 no exec authorization
 no login authentication
 vrf tester
 exit
!
!
end
```

**r2:**
```
hostname r2
buggy
!
logging file debug ./slot0r2-log.run
!
vrf definition cust2
 exit
!
vrf definition tester
 exit
!
interface ethernet1
 lldp enable
 vrf forwarding cust2
 ipv4 address 4.4.4.1 255.255.255.252
 no shutdown
 no log-link-change
 exit
!
console0
 no exec authorization
 no login authentication
 exit
!
!
ipv4 route cust2 0.0.0.0 0.0.0.0 4.4.4.2
!
!
!
!
!
!
!
!
!
!
!
!
!
!
!
!
!
!
!
!
!
!
!
!
!
server telnet tester
 security protocol telnet
 exec colorize header
 exec monitor
 no exec authorization
 no login authentication
 vrf tester
 exit
!
!
end
```

**r3:**
```
hostname r3
buggy
!
logging file debug ./slot0r3-log.run
!
vrf definition blue
 rd 1:3
 rt4import 1:3
 rt4export 1:3
 clr4import 3
 clr4export 3
 exit
!
vrf definition core
 label4mode per-prefix
 exit
!
vrf definition cust1
 rd 1:11
 rt4import 1:11
 rt4export 1:11
 exit
!
vrf definition cust2
 rd 1:22
 rt4import 1:22
 rt4export 1:22
 exit
!
vrf definition red
 rd 1:2
 rt4import 1:2
 rt4export 1:2
 clr4import 2
 clr4export 2
 exit
!
vrf definition tester
 exit
!
interface loopback0
 vrf forwarding core
 ipv4 address 2.2.2.3 255.255.255.255
 no shutdown
 no log-link-change
 exit
!
interface loopback1
 vrf forwarding red
 ipv4 address 2.2.22.3 255.255.255.255
 no shutdown
 no log-link-change
 exit
!
interface loopback2
 vrf forwarding blue
 ipv4 address 2.2.33.3 255.255.255.255
 no shutdown
 no log-link-change
 exit
!
interface ethernet1
 lldp enable
 vrf forwarding cust1
 ipv4 address 3.3.3.2 255.255.255.252
 no shutdown
 no log-link-change
 exit
!
interface ethernet2
 lldp enable
 vrf forwarding cust2
 ipv4 address 4.4.4.2 255.255.255.252
 no shutdown
 no log-link-change
 exit
!
interface ethernet3
 lldp enable
 vrf forwarding core
 ipv4 address 1.1.1.1 255.255.255.252
 mpls enable
 no shutdown
 no log-link-change
 exit
!
router bgp4 1 vrf core
 local-as 1
 router-id 2.2.2.3
 address-family ctp
 !
 neighbor 1.1.1.2 remote-as 2
 neighbor 1.1.1.2 local-as 1
 neighbor 1.1.1.2 address-family ctp
 neighbor 1.1.1.2 distance 20
 neighbor 1.1.1.2 send-community all
 !
 afi-clr blue enable
 afi-clr blue redistribute connected
 !
 afi-clr red enable
 afi-clr red redistribute connected
 !
 !
 redistribute connected
 exit
!
router bgp4 2 vrf red
 local-as 1
 router-id 2.2.22.3
 address-family vpnuni
 !
 neighbor 2.2.22.5 remote-as 2
 neighbor 2.2.22.5 local-as 1
 neighbor 2.2.22.5 address-family vpnuni
 neighbor 2.2.22.5 distance 20
 neighbor 2.2.22.5 update-source loopback1
 neighbor 2.2.22.5 send-community all
 !
 afi-vrf cust1 enable
 afi-vrf cust1 redistribute connected
 !
 !
 exit
!
router bgp4 3 vrf blue
 local-as 1
 router-id 2.2.33.3
 address-family vpnuni
 !
 neighbor 2.2.33.5 remote-as 2
 neighbor 2.2.33.5 local-as 1
 neighbor 2.2.33.5 address-family vpnuni
 neighbor 2.2.33.5 distance 20
 neighbor 2.2.33.5 update-source loopback2
 neighbor 2.2.33.5 send-community all
 !
 afi-vrf cust2 enable
 afi-vrf cust2 redistribute connected
 !
 !
 exit
!
console0
 no exec authorization
 no login authentication
 exit
!
!
!
!
!
!
!
!
!
!
!
!
!
!
!
!
!
!
!
!
!
!
!
!
!
!
!
!
!
!
!
!
!
!
!
!
!
!
!
!
!
!
!
!
!
!
!
!
!
!
!
!
!
!
!
!
!
!
!
!
!
!
!
!
!
!
!
!
!
!
!
!
!
!
!
!
!
!
!
server telnet tester
 security protocol telnet
 exec colorize header
 exec monitor
 no exec authorization
 no login authentication
 vrf tester
 exit
!
!
end
```

**r4:**
```
hostname r4
buggy
!
logging file debug ./slot0r4-log.run
!
vrf definition blue
 rd 1:3
 rt4import 1:3
 rt4export 1:3
 clr4import 3
 clr4export 3
 exit
!
vrf definition core
 label4mode per-prefix
 exit
!
vrf definition red
 rd 1:2
 rt4import 1:2
 rt4export 1:2
 clr4import 2
 clr4export 2
 exit
!
vrf definition tester
 exit
!
router isis4 1 vrf core
 net-id 48.0000.0000.4444.00
 traffeng-id ::
 is-type level2
 level2 traffeng
 redistribute connected
 exit
!
interface loopback0
 vrf forwarding core
 ipv4 address 2.2.2.4 255.255.255.255
 router isis4 1 enable
 router isis4 1 circuit level2
 router isis4 1 traffeng bandwidth 1000000000
 no shutdown
 no log-link-change
 exit
!
interface loopback1
 vrf forwarding red
 ipv4 address 2.2.22.4 255.255.255.255
 no shutdown
 no log-link-change
 exit
!
interface loopback2
 vrf forwarding blue
 ipv4 address 2.2.33.4 255.255.255.255
 no shutdown
 no log-link-change
 exit
!
interface ethernet1
 lldp enable
 vrf forwarding core
 ipv4 address 1.1.1.2 255.255.255.252
 mpls enable
 no shutdown
 no log-link-change
 exit
!
interface ethernet2
 lldp enable
 vrf forwarding core
 ipv4 address 1.1.1.5 255.255.255.252
 mpls enable
 mpls ldp4
 router isis4 1 enable
 router isis4 1 circuit level2
 no shutdown
 no log-link-change
 exit
!
router bgp4 1 vrf core
 local-as 2
 router-id 2.2.2.4
 address-family ctp
 !
 neighbor 1.1.1.1 remote-as 1
 neighbor 1.1.1.1 local-as 2
 neighbor 1.1.1.1 address-family ctp
 neighbor 1.1.1.1 distance 20
 neighbor 1.1.1.1 send-community all
 !
 neighbor 2.2.2.5 remote-as 2
 neighbor 2.2.2.5 local-as 2
 neighbor 2.2.2.5 address-family ctp
 neighbor 2.2.2.5 distance 200
 neighbor 2.2.2.5 update-source loopback0
 neighbor 2.2.2.5 send-community all
 !
 afi-clr blue enable
 afi-clr blue redistribute connected
 !
 afi-clr red enable
 afi-clr red redistribute connected
 !
 !
 redistribute connected
 exit
!
console0
 no exec authorization
 no login authentication
 exit
!
!
!
!
!
!
!
!
!
!
!
!
!
!
!
!
!
!
!
!
!
!
!
!
!
!
!
!
!
!
!
!
!
!
!
!
!
!
!
!
!
!
!
!
!
!
!
!
!
!
!
!
!
server telnet tester
 security protocol telnet
 exec colorize header
 exec monitor
 no exec authorization
 no login authentication
 vrf tester
 exit
!
!
end
```

**r5:**
```
hostname r5
buggy
!
logging file debug ./slot0r5-log.run
!
vrf definition blue
 rd 1:3
 rt4import 1:3
 rt4export 1:3
 clr4import 3
 clr4export 3
 exit
!
vrf definition core
 label4mode per-prefix
 exit
!
vrf definition cust1
 rd 1:11
 rt4import 1:11
 rt4export 1:11
 exit
!
vrf definition cust2
 rd 1:22
 rt4import 1:22
 rt4export 1:22
 exit
!
vrf definition red
 rd 1:2
 rt4import 1:2
 rt4export 1:2
 clr4import 2
 clr4export 2
 exit
!
vrf definition tester
 exit
!
router isis4 1 vrf core
 net-id 48.0000.0000.5555.00
 traffeng-id ::
 is-type level2
 level2 traffeng
 redistribute connected
 exit
!
interface loopback0
 vrf forwarding core
 ipv4 address 2.2.2.5 255.255.255.255
 router isis4 1 enable
 router isis4 1 circuit level2
 router isis4 1 traffeng bandwidth 1000000000
 no shutdown
 no log-link-change
 exit
!
interface loopback1
 vrf forwarding red
 ipv4 address 2.2.22.5 255.255.255.255
 no shutdown
 no log-link-change
 exit
!
interface loopback2
 vrf forwarding blue
 ipv4 address 2.2.33.5 255.255.255.255
 no shutdown
 no log-link-change
 exit
!
interface ethernet1
 lldp enable
 vrf forwarding core
 ipv4 address 1.1.1.6 255.255.255.252
 mpls enable
 mpls ldp4
 router isis4 1 enable
 router isis4 1 circuit level2
 no shutdown
 no log-link-change
 exit
!
interface ethernet2
 lldp enable
 vrf forwarding cust1
 ipv4 address 3.3.3.6 255.255.255.252
 no shutdown
 no log-link-change
 exit
!
interface ethernet3
 lldp enable
 vrf forwarding cust2
 ipv4 address 4.4.4.6 255.255.255.252
 no shutdown
 no log-link-change
 exit
!
router bgp4 1 vrf core
 local-as 2
 router-id 2.2.2.5
 address-family ctp
 !
 neighbor 2.2.2.4 remote-as 2
 neighbor 2.2.2.4 local-as 2
 neighbor 2.2.2.4 address-family ctp
 neighbor 2.2.2.4 distance 200
 neighbor 2.2.2.4 update-source loopback0
 neighbor 2.2.2.4 send-community all
 !
 afi-clr blue enable
 afi-clr blue redistribute connected
 !
 afi-clr red enable
 afi-clr red redistribute connected
 !
 !
 redistribute connected
 exit
!
router bgp4 2 vrf red
 local-as 2
 router-id 2.2.22.5
 address-family vpnuni
 !
 neighbor 2.2.22.3 remote-as 1
 neighbor 2.2.22.3 local-as 2
 neighbor 2.2.22.3 address-family vpnuni
 neighbor 2.2.22.3 distance 20
 neighbor 2.2.22.3 update-source loopback1
 neighbor 2.2.22.3 send-community all
 !
 afi-vrf cust1 enable
 afi-vrf cust1 redistribute connected
 !
 !
 exit
!
router bgp4 3 vrf blue
 local-as 2
 router-id 2.2.33.5
 address-family vpnuni
 !
 neighbor 2.2.33.3 remote-as 1
 neighbor 2.2.33.3 local-as 2
 neighbor 2.2.33.3 address-family vpnuni
 neighbor 2.2.33.3 distance 20
 neighbor 2.2.33.3 update-source loopback2
 neighbor 2.2.33.3 send-community all
 !
 afi-vrf cust2 enable
 afi-vrf cust2 redistribute connected
 !
 !
 exit
!
console0
 no exec authorization
 no login authentication
 exit
!
!
!
!
!
!
!
!
!
!
!
!
!
!
!
!
!
!
!
!
!
!
!
!
!
!
!
!
!
!
!
!
!
!
!
!
!
!
!
!
!
!
!
!
!
!
!
!
!
!
!
!
!
!
!
!
!
!
!
!
!
!
!
!
!
!
!
!
!
!
!
!
!
!
!
!
!
!
!
server telnet tester
 security protocol telnet
 exec colorize header
 exec monitor
 no exec authorization
 no login authentication
 vrf tester
 exit
!
!
end
```

**r6:**
```
hostname r6
buggy
!
logging file debug ./slot0r6-log.run
!
vrf definition cust1
 exit
!
vrf definition tester
 exit
!
interface ethernet1
 lldp enable
 vrf forwarding cust1
 ipv4 address 3.3.3.5 255.255.255.252
 no shutdown
 no log-link-change
 exit
!
console0
 no exec authorization
 no login authentication
 exit
!
!
ipv4 route cust1 0.0.0.0 0.0.0.0 3.3.3.6
!
!
!
!
!
!
!
!
!
!
!
!
!
!
!
!
!
!
!
!
!
!
!
!
!
server telnet tester
 security protocol telnet
 exec colorize header
 exec monitor
 no exec authorization
 no login authentication
 vrf tester
 exit
!
!
end
```

**r7:**
```
hostname r7
buggy
!
logging file debug ./slot0r7-log.run
!
vrf definition cust2
 exit
!
vrf definition tester
 exit
!
interface ethernet1
 lldp enable
 vrf forwarding cust2
 ipv4 address 4.4.4.5 255.255.255.252
 no shutdown
 no log-link-change
 exit
!
console0
 no exec authorization
 no login authentication
 exit
!
!
ipv4 route cust2 0.0.0.0 0.0.0.0 4.4.4.6
!
!
!
!
!
!
!
!
!
!
!
!
!
!
!
!
!
!
!
!
!
!
!
!
!
server telnet tester
 security protocol telnet
 exec colorize header
 exec monitor
 no exec authorization
 no login authentication
 vrf tester
 exit
!
!
end
```
